<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Ringbuffer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classRingbuffer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Ringbuffer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classRingbuffer.html" title="Ringbuffer.">Ringbuffer</a>.  
 <a href="classRingbuffer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="FreeRTOS_8h_source.html">FreeRTOS.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a32e23dca7a30bc6d1d4b5c10ecbfbc52"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRingbuffer.html#a32e23dca7a30bc6d1d4b5c10ecbfbc52">Ringbuffer</a> (size_t length, ringbuf_type_t type=RINGBUF_TYPE_NOSPLIT)</td></tr>
<tr class="memdesc:a32e23dca7a30bc6d1d4b5c10ecbfbc52"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a ring buffer.  <a href="#a32e23dca7a30bc6d1d4b5c10ecbfbc52">More...</a><br /></td></tr>
<tr class="separator:a32e23dca7a30bc6d1d4b5c10ecbfbc52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2de1d3d2c869875883b351e66212dfef"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRingbuffer.html#a2de1d3d2c869875883b351e66212dfef">receive</a> (size_t *size, TickType_t wait=portMAX_DELAY)</td></tr>
<tr class="memdesc:a2de1d3d2c869875883b351e66212dfef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive data from the buffer.  <a href="#a2de1d3d2c869875883b351e66212dfef">More...</a><br /></td></tr>
<tr class="separator:a2de1d3d2c869875883b351e66212dfef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a145b135c71d2e715f13bdbe186e45cc6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRingbuffer.html#a145b135c71d2e715f13bdbe186e45cc6">returnItem</a> (void *item)</td></tr>
<tr class="memdesc:a145b135c71d2e715f13bdbe186e45cc6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return an item.  <a href="#a145b135c71d2e715f13bdbe186e45cc6">More...</a><br /></td></tr>
<tr class="separator:a145b135c71d2e715f13bdbe186e45cc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4700ffc589022ed2dee5c069f583d7c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRingbuffer.html#ac4700ffc589022ed2dee5c069f583d7c">send</a> (void *data, size_t length, TickType_t wait=portMAX_DELAY)</td></tr>
<tr class="memdesc:ac4700ffc589022ed2dee5c069f583d7c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send data to the buffer.  <a href="#ac4700ffc589022ed2dee5c069f583d7c">More...</a><br /></td></tr>
<tr class="separator:ac4700ffc589022ed2dee5c069f583d7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classRingbuffer.html" title="Ringbuffer.">Ringbuffer</a>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a32e23dca7a30bc6d1d4b5c10ecbfbc52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a32e23dca7a30bc6d1d4b5c10ecbfbc52">&#9670;&nbsp;</a></span>Ringbuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ringbuffer::Ringbuffer </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ringbuf_type_t&#160;</td>
          <td class="paramname"><em>type</em> = <code>RINGBUF_TYPE_NOSPLIT</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a ring buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The amount of storage to allocate for the ring buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">type</td><td>The type of buffer. One of RINGBUF_TYPE_NOSPLIT, RINGBUF_TYPE_ALLOWSPLIT, RINGBUF_TYPE_BYTEBUF. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a2de1d3d2c869875883b351e66212dfef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2de1d3d2c869875883b351e66212dfef">&#9670;&nbsp;</a></span>receive()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void * Ringbuffer::receive </td>
          <td>(</td>
          <td class="paramtype">size_t *&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TickType_t&#160;</td>
          <td class="paramname"><em>wait</em> = <code>portMAX_DELAY</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receive data from the buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">size</td><td>On return, the size of data returned. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">wait</td><td>How long to wait. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the storage retrieved. </dd></dl>

</div>
</div>
<a id="a145b135c71d2e715f13bdbe186e45cc6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a145b135c71d2e715f13bdbe186e45cc6">&#9670;&nbsp;</a></span>returnItem()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ringbuffer::returnItem </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return an item. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">item</td><td>The item to be returned/released. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac4700ffc589022ed2dee5c069f583d7c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac4700ffc589022ed2dee5c069f583d7c">&#9670;&nbsp;</a></span>send()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ringbuffer::send </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TickType_t&#160;</td>
          <td class="paramname"><em>wait</em> = <code>portMAX_DELAY</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send data to the buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The data to place into the buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The length of data to place into the buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">wait</td><td>How long to wait before giving up. The default is to wait indefinitely. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd></dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="FreeRTOS_8h_source.html">FreeRTOS.h</a></li>
<li>FreeRTOS.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
